val lessThanEpsilon : float -> bool
val pi : float
val deg2rad : float
val rad2deg : float
val vectorLength : float array -> float
val vectorScale : float -> float array -> float array
val vectorAdd : float array -> float array -> float array
val vectorSub : float array -> float array -> float array
val vectorDotProduct : float array -> float array -> float
val vectorNormalize : float array -> float array * float
val vectorCrossProduct : float array -> float array -> float array
val vectorTransform : float array -> float array -> float array
val vectorTransformNormal : float array -> float array -> float array
val matrixMultiply : float array -> float array -> float array
val matrixInverse : float array -> bool * float array
val matrixTranspose : float array -> float array
val matrixRotationX : float -> float array
val matrixRotationY : float -> float array
val matrixRotationZ : float -> float array
val matrixTranslate : float -> float -> float -> float array
val matrixLookAt : float array -> float array -> float array -> float array
val matrixShadow : float array -> float array -> float array
val quaternionSet : float array -> float -> float array
val quaternionCopy : 'a array -> 'a array
val quaternionMultiply : float array -> float array -> float array
val quaternionToMatrix : float array -> float array